VERSION 5.00
Begin VB.Form FrmCreateADoc 
   Caption         =   "Create a Document"
   ClientHeight    =   1080
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2295
   LinkTopic       =   "Form1"
   ScaleHeight     =   1080
   ScaleWidth      =   2295
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCreateADoc 
      Caption         =   "Create a Document"
      Height          =   735
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "FrmCreateADoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'  Creation Date:   March 5, 2000
'  Programmer:      Ronald Garlit
'  Functionality:   Basic example of automating MS Word from
'                   Visual Basic 6.
'  Arguments:       N/A
'  Special Notes:   This is project is used to demonstrate the
'                   basics of:
'
'                   1)  Creating and instance of MS Word
'                   programatically.
'
'                   2)  Settting up and calling documents by name.
'
'                   3)  Using ActiveDocument.  The Warning!!
'
'                   4)  A small taste of the Range Object.
'~***************************************************************
Option Explicit
Public objWord As Word.Application   '  Declare a word app var
Dim aThisDoc As Document             '  Delcare a document variable
Dim aThatDoc As Document             '  Delcare another document variable
Dim strWorkingDocName As String      '  String for working document name
Dim range1 As Range                  '  Range variable to hold reference to Range Object
Dim range2 As Range                  '  Range variable to hold reference to Range Object

Private Sub cmdCreateADoc_Click()
    IsProgramRunningWord
    Dim aWorking As Document
    '  *************************************************
    '  Visibility of Word control
    '
    '  Word normally runs invisible when called in
    '  automation code.  We like this because this
    '  allows us to use it to replace the VB Printer
    '  Object.  We can then create really cool reports
    '  from a database quickly.
    '
    '  But for our purposes we need to make our
    '  instance of Word Visible.  So you must ALWAYS
    '  be aware of the state of your instance of word.
    '
    '  During development you must watch that you do
    '  not leave invisible instances of word on the
    '  computer.  It will come back to haunt you.
    '
    '  You can check this by using the systems task
    '  manager.  If you think all instances of word
    '  are closed and you see a instance of Winword.
    '  exe in the task manager perform a END TASK on
    '  it.
    '  *************************************************
    With objWord
        .WindowState = wdWindowStateNormal
        .Visible = True
    End With
    With objWord
        '  *************************************************
        '  Create the first document to be added to our
        '  instance of Word.
        '  *************************************************
        .Documents.Add
        '  *************************************************
        '  Immediately assign the name using the
        '  ActiveDocument.Name property to get the name of
        '  the document.  This is one of the few times I
        '  condone the use of ActiveDocument.  Your still
        '  in control.
        '  *************************************************
        strWorkingDocName = .ActiveDocument.Name
        '  *************************************************
        '  Call the document by name and assign it to
        '  aThisDoc which is a variable of the type
        '  document.   We will use this for just about
        '  everything related to THAT document.
        '  *************************************************
        Set aThatDoc = .Documents(strWorkingDocName)
        '  *************************************************
        '  Create the second document to be added to our
        '  instance of Word.
        '  *************************************************
        .Documents.Add
        '  *************************************************
        '  Immediately assign the name using the
        '  ActiveDocument.Name property to get the name of
        '  the document.  This is one of the few times I
        '  condone the use of ActiveDocument.  Your still
        '  in control.
        '  *************************************************
        strWorkingDocName = .ActiveDocument.Name
        '  *************************************************
        '  Call the document by name and assign it to
        '  aThisDoc which is a variable of the type
        '  document.   We will use this for just about
        '  everything related to THIS document.
        '  *************************************************
        Set aThisDoc = .Documents(strWorkingDocName)
        '  *************************************************
        '  Now for a small taste of the fun stuff.  If
        '  your following the trail you will note that we
        '  are assigning the RANGE OBJECT of each the
        '  DOCUMENTs to range variables.
        '
        '  This simplifies using the range object.  This
        '  also makes the program execute faster.
        '  *************************************************
        Set range1 = aThisDoc.Range
        Set range2 = aThatDoc.Range
        '  *************************************************
        '  We are now using the InsertAfter Method of the
        '  Range Object to print some text into the
        '  document.
        '
        '  Note the construction of the text in these
        '  calls.  The document variables are being called
        '  to reference the Name property of the document
        '  the variable represents.
        '  *************************************************
        range1.InsertAfter "This is the range object that was just assign the range of " & aThisDoc.Name
        range2.InsertAfter "This is the range object that was just assign the range of " & aThatDoc.Name
        '*************************************************
        '  Use the Select Method to highlight the Range so
        '  we can see it as we step through the code.
        '
        '  The Collapse the range end to the end of the
        '  range.
        '
        '  The Collapse the Start of the Range to the End.
        '
        '  Then use InsertAfter Method to put text at the
        '  end of the Range.
        '*************************************************
        range1.Select   ' Highlight the range
        range1.Collapse wdCollapseEnd   'collapse the beginning of the range to the END of range.
        range1.Select   ' Highlight the change range
        range1.InsertAfter "We just collapsed to the end of Range1.  That means we moved an invisible cursor to the end of sentence."
    End With    '}-> With objWord

End Sub

Public Sub IsProgramRunningWord()
    '  Create Word instance if necessary
    '  Change test to use IS operator based on new information
    '  related to Winword instance error and objects (RAG)
    If objWord Is Nothing Then
        '  *************************************************
        '  Create new Word instance if word isn't running
        '  *************************************************
        Set objWord = New Word.Application
    Else
        '  *************************************************
        '  Use an existing instance created by our program
        '  *************************************************
        Set objWord = GetObject(, "Word.Application")
    End If    '}-> If objWord Is Nothing Then
End Sub



